'use strict';

var fs = require('fs');
var path = require('path');

var index = require('./index.js');

var scriptName = process.argv[2].trim();
var dirName = process.cwd();
var rcFilePath = path.join(dirName, '.scriptsrc');

// global config
var gConfig = JSON.parse(fs.readFileSync(rcFilePath, 'utf8'));

switch (scriptName) {
  case 'serve':
    {
      var config = gConfig.serve;
      config.entry = gConfig.entry;
      config.rootPath = dirName;
      config.schema = Object.assign(config.schema, gConfig.schema);

      index.serve(config);
      break;
    }

  case 'build':
    {
      var _config = gConfig.build;
      index.build(_config);
      break;
    }

  case 'test':
    {
      var _config2 = gConfig.test;
      index.test(_config2);
      break;
    }

  default:
    {
      console.log(scriptName + ' command not found.');
    }
}